# Formale Notation
## Mengen
### Reelle Zahlen
$\mathbb{R}$

### Ohne
$\mathbb{R} \setminus 1$

> ***Note:***  
> Gesprochen: "Alle reellen Zahlen ($\mathbb{R}$) ohne 1."

$\mathbb{D} = [0, \infty[$ (gesprochen: "Alle Zahlen ab 0 ohne $\infty$)

### Fakultät
Die Fakultät errechnet sich, indem man die Werte aller Zahlen in einer Zahlenwerte summiert.

So berechnet sich die Fakultät von $100$ bspw. indem man folgendes rechnet:
$$1 + 2 + 3 + 4 + 5 + 6 +...+100$$

Bildet man jedoch die Zahlenreihe zweimal in entgegengesetzter Richtung, wird möglicherweise auffallen, dass sich jeweils Zahlenpaare bilden, die immer die Summe der äussersten Zahlen der Reihe zusammenrechnet:

$$\underbrace{1}_{100} + \underbrace{2}_{99} + \underbrace{3}_{98} ... + \underbrace{100}_{1}$$

Alle Zahlenpaare zusammen ergeben $100 \times 101$.

Da in dieser Zusammenfassung jedes Zahlenpaar doppelt vorkommt, muss die Lösung dieser Rechnung halbiert werden, um die Lösung der Fakultät zu erhalten:

$$\sum^{100}_{k=1}k = \frac{100 \times (100 + 1)}{2} = 5050$$

Dementsprechend kann auch die Fakultät anderer Zahlen errechnet werden:

$$\sum^{n}_{k=1}k = \frac{n \times (n + 1)}{2}$$

#### Quadrat Gagg
$$\sum^{n}_{k=1}k^2 = \frac{n \cdot (n + 1) \cdot (2n + 1)}{6}$$
