# Mengen, Relationen und Funktionen
## Mengen
Zusammenfassung **unterscheidbarer** Objekte

> **Beispiele:**  
> * Folgendes sind Mengen:
>   * ${1, 2, 3}$
>   * Mitglieder einer Klasse
>   * Wesen einer bestimmten Spezies
> * Folgendes sind **keine** Mengen:
>   * ${1, 1, 3}$
>   * Personen mit schlechtem Gedankengut
>     * ***Anmerkung:*** Keine Menge, da der Term "schlecht" nicht genauer beschrieben wird

### Gleichheit von Mengen
Zwei Mengen sind genau dann gleich, wenn die dieselben Elemente enthalten. Es gilt für alle Mengen $\mathbb{X}$ und $\mathbb{Y}$ die Äquivalenz, wenn folgendes zutrifft:

**Im Scrtipt nachlesen - Definition 15**

### Eigenschaften von Mengen
#### Sortierung
Mengen sind unsortiert folglich gilt folgendes:
$$\{1,2,3\} = \{2,3,1\} = \{1,3,2\}$$

### Spezielle Zahlenmengen
#### Natürliche Zahlen $\mathbb{N}$
Die natürlichen zahlen beinhalten alle positiven, ganzen Zahlen.
Üblicherweise ist in diesen die $0$ **nicht** mit eingeschlossen. Um dies eindeutig zu kennzeichnen, kann man die Menge auch als $\mathbb{N}_0$ schreiben.
$$\mathbb{N} = \{\mathbb{N}_{\ge 1}\} = \{ 1, 2, 3, ...\}$$
$$\mathbb{N}_0 = \{\mathbb{N}_{\ge 0}\} = \{ 0, 1, 2, 3, ... \}$$

#### Ganze Zahlen $\mathbb{Z}$
$\mathbb{Z}$ beinhaltet alle ganzzahligen Werte. Des weiteren kann man die Menge $\mathbb{Z}$ in einer Notation schreiben, um klarzustellen, ob nur positive oder nur negative Zahlen gemeint sind ($\mathbb{Z}^+$ und $\mathbb{Z}^-$). Wird die Menge mit keiner besonderen Notation geschrieben, sind sowohl positive als auch negative Zahlen (inkl. $0$) gemeint.

$$\mathbb{Z} : \text{ganze Zahlen}$$
$$\mathbb{Z} = \{..., -2, -1, 0, 1, 2 ...\}$$
$$\mathbb{Z}^+ : \text{positive Zahlen}$$
$$\mathbb{Z}^- : \text{negative Zahlen}$$

#### Rationale Zahlen $\mathbb{Q}$
Rationale Zahlen sind Zahlen, die sich als einfacher Bruch darstellen lassen. So ist bspw. $\frac{1}{\sqrt{2}}$ **keine** rationale Zahl, da sich dieser Term nicht als einfacher Bruch darstellen lässt, denn $\sqrt{2}$ lässt sich nicht berechnen.

> ***Beispiele:***
> $$\frac{2}{3}$$
> $$\frac{1}{2}$$

#### Reelle Zahlen $\mathbb{R}$

$$\mathbb{R} : \text{reelle Zahlen}$$
**Beispiele** $\sqrt{2}, \pi, e$
$$\mathbb{C} : \text{komplexe Zahlen}$$
Unmögliche Zahlen wie bspw. negaive Wurzeln

### Intervallschreibweise
$$[a,b]:= \{ x \in \mathbb{R} | a \leq x \leq b \}$$

Falls in einer in der Intervallschreibweise geschriebenen Menge kein Definitionsbereich angegeben wird, wird implizit mit $\mathbb{R}$ (reellen Zahlen) gearbeitet.

$$]a, b[ = (a, b) = \{x\in \mathbb{R} | a < x < b\}$$

### Prädikatschreibweise


## Relationen
### Operationen auf Relationen
1. Komposition $\circ$ (hintereinander ausführen)

$$R = \{(1, a), (2, b), (3, c)\}  \subseteq A \times B$$

Surrjektiv - Rechtstotal
Zu jedem "b" hat es mindestens ein "a"

Injektiv - Linkseindeutig
Zu jedem "b" gibt es maximal ein "a"

Bijektiv (Surjektiv & ijketiv)
Zu jedem "b" gibt es genau ein "a"

### Unendlich grosse Mengen
Endlich grosse Mengen lassen sich vergleichen, indem man die Mächtigkeit gegenüberstellt - also die Anzahl der Elemente in $A$ und die Anzahl Elemente in $B$ und diese vergleicht.

In unendlich grossen Mengen ist dies jedoch unmöglich.

#### Abzählbarkeit
  1. Jede endliche Menge ist abzählbar
  2. Jede Teilmenge ist abzählbar
  3. Ist $X$ eine abzählbare Menge & gibt es eine surjektive Funktion $F: X \rightarrow Y$, dann ist auch $Y$ abzählbar
  4. Gibt es keine solche Funktion, ist $Y$ überabzählbar

Beispiele von Menge:
  - Abzählbar
    - $\mathbb{M}$, $\mathbb{Z}$, $\mathbb{Q}$, $\mathbb{N} \times \mathbb{N}$

## 2021-11-23
  - Beweismethode kleinster Verbrecher (Script Beispiel 50)
    - 