<script src="../../../assets/deployggb.js"></script>
<script src="../../../assets/graphs.js"></script>
<script>
    window.graphs(
        [
            [
                "example",
                [
                    "f(x) = x^3 + 5",
                    "a = IntegralBetween(f(x), 2, 4)",
                    "SetCaption(a, \"Integral\")",
                    "SetCaption(f, \"f(x)\")"
                ],
                undefined,
                (api) =>
                {
                    api.setColor("a", 255, 0, 0);
                    api.evalCommand("ZoomIn(-10, -10, 10, 100)");
                    api.evalCommand("ShowLabel(a, true)");
                }
            ]
        ])
</script>

# Zusammenfassung Analysis 2
## Inhalt
- [Zusammenfassung Analysis 2](#zusammenfassung-analysis-2)
  - [Inhalt](#inhalt)
  - [Integrale](#integrale)
    - [Unbestimmte Integrale](#unbestimmte-integrale)
    - [Integration von Produkten](#integration-von-produkten)
      - [Integration durch Substitution](#integration-durch-substitution)
        - [Schritt 1: Verschachtelte Funktionen Bestimmen](#schritt-1-verschachtelte-funktionen-bestimmen)
        - [Schritt 2: Substitutions-Gleichung für $x$](#schritt-2-substitutions-gleichung-für-x)
        - [Schritt 3: Substitutions-Gleichung für $dx$](#schritt-3-substitutions-gleichung-für-dx)
        - [Schritt 4: Integral-Substitution](#schritt-4-integral-substitution)
  - [Taylor-Reihe](#taylor-reihe)

## Integrale
Integrale dienen dazu, die Flächen unter einer Kurve zu berechnen.

<p id="example"></p>

Mit der Funktion $f(x) = x^3 + 5$ lässt sich dessen Integral folgendermassen darstellen:

$$\int_{2}^4{f(x)dx}$$

oder

$$\int_{2}^4{\left(x^3 + 5\right)dx}$$

Berechnen lässt sich das Integral mit Hilfe der Basisfunktion:

$$F(x) = \frac{1}{4}x^4 + 5x$$

Folgend lautet die Integration:

$$\int_{2}^4{f(x)dx} = F(4) - F(2)$$

oder

$$\int_{2}^4{f(x)dx} = \left(\frac{1}{4}4^4 + 5 \cdot 4\right) - \left(\frac{1}{4} \cdot 2^4 + 5 \cdot 2\right) \\
\int_{2}^4{f(x)dx} = \frac{1}{4} \cdot 256 + 20 - \frac{1}{4} \cdot 16 - 10 \\
\int_{2}^4{f(x)dx} = 64 + 20 - 4 - 10 = 70$$

### Unbestimmte Integrale
Integrale können in unbestimmter oder in bestimmter Form geschrieben werden. Unbestimmte Integrale haben - anders als bestimmte Integrale - keinen festgelegte Grenzwerte.

Aus diesem Grund können diese nicht eindeutig berechnet werden:

$$\int{x^3 + 5dx} = F(x) = \frac{1}{4}x^4 + 5x + C$$

> ***Informationen zur Konstanten $C$:***  
> Da in der Ableitung von $f(x) = x^3 + 5$ eine beliebige Konstante $C$ zulässt, kann die Ableitung nicht eindeutig bestimmt werden. Nur durch Setzen von Grenzen lässt sich die Konstante **eliminieren**:
> $$\int_{-1}^1{x^3 + 5dx} = F(1) - F(-1) \\
> \int_{-1}^1{x^3 + 5dx} = \left(\frac{1}{4} \cdot 1^4 + 5 \cdot 1 + C\right) - \left(\frac{1}{4} + 5 \cdot -1 + C\right) \\
> \int_{-1}^1{x^3 + 5dx} = \frac{1}{4} + 5 + C - \frac{1}{4} + 5 - C \\
> \int_{-1}^1{x^3 + 5dx} = 5 + 5 + \frac{1}{4} - \frac{1}{4} + C - C = 10$$

### Integration von Produkten
Da Produkte sowohl durch Produktregel oder durch Kettenregel entstandene Ableitungen sein können, ist das Bestimmen der Basisfunktion von Produkten etwas komplizierter.

So kann ein Produkt von folgenden 2 Ableitungen[^Derivation] stammen:

$$\left(u(x) \cdot v(x) \right)' = u'(x) \cdot v(x) + u(x) \cdot v'(x)$$

oder

$$(u(v(x)))' = u'(v(x)) \cdot v'(x)$$

Die zwei gängigsten Methoden sind im folgenden beschrieben:

#### Integration durch Substitution
Diese Methode basiert auf folgende Ableitungs-Regel[^Derivation].

$$F(u(x)) = \int{F(u(x))' dx} = \int{F'(u) \cdot u'(x) dx}$$

Gelöst wird das Ganze mit der Regel $\frac{du}{dx} = g'(x)$ für $u = g(x)$.

Aufgezeigt wird das anhand eines bestimmten und eines unbestimmten Integrals:

  - Beispiel a)
    $$\int{\left(\cos(x^2) \cdot x\right) dx}$$
  - Beispiel b)  
    $$\int^{\sqrt{\frac{\pi}{2}}}_0\left(\cos(x^2) \cdot x\right) dx$$

##### Schritt 1: Verschachtelte Funktionen Bestimmen
In diesem Schritt sollen die verschachtelten Funktionen für spätere Funktionen bestimmt werden:

Für Beispiel a) und b) mit $f(g(x)) = \cos(x^2) \cdot x$:
  - $f(x) = \cos(g(x)) \cdot x$
  - $g(x) = x^2$

##### Schritt 2: Substitutions-Gleichung für $x$
$$u = g(x)$$

Für Beispiel a) und b) bedeutet das:  
$$u = x^2$$

> ***Note:***  
> Eine verschachtelte Funktion wird üblicherweise mit $g(x)$ bezeichnet.

##### Schritt 3: Substitutions-Gleichung für $dx$
$$\frac{du}{dx} = g'(x) \Rightarrow dx = \frac{du}{g'(x)}$$

Im Fall von Beispiel a) und b) entspricht die Ableitung $g'(x)$ $2x$.

Für Beispiel a) und b) bedeutet das folgendes:

$$\frac{du}{dx} = 2x \Rightarrow dx = \frac{du}{2x}$$

##### Schritt 4: Integral-Substitution
$$\int{f(x) dx} = \int{\varphi(u) du}$$

Die genannte Formel muss nun auf das Integral und das substituierte Integral angewendet werden.

Hierbei soll die Variable $x$ weggekürzt werden. Ist dies nicht möglich, so ist dieser Ansatz "Integration durch Substitution" für dieses Integral nicht möglich.

***Beispiel a)***  
$$\int{\left(\cos(x^2) \cdot x\right) dx} = \int{\left(\cos(u) \cdot x\right) \frac{du}{2x}} \\
\int{\left(\cos(x^2) \cdot x\right) dx}$$

## Taylor-Reihe

[^Derivation]: [Ableitungen](../.../../../Semester%201/AN1%20-%20Analysis%201/Ableitungen.md)
